
#define	rtl_no_interrupts(s) \
__asm__ __volatile__("pushfl ; popl %0; cli":"=g" (s): /* no input */ :"memory")

#define	 rtl_restore_interrupts(s)\
__asm__ __volatile__("pushl %0 ; popfl": /* no output */ :"g" (s):"memory")

#define	 rtl_stop_interrupts()\
__asm__ __volatile__("cli": /* no output,no input */ ::"memory")

#define	 rtl_allow_interrupts() \
__asm__ __volatile__("sti": /* no output,no input */ :: "memory")


#ifdef __SMP__
#define rtl_spin_lock(x)  { static int z;\
	                        for(z=0;z<1000000000;z++)\
					                          if(!test_and_set_bit(0,x.lock))break;\
									                            if(z==1000000000){ conpr("\nRTLBADSpin=");\
													                                                conprn((unsigned int)&z);\
																				                                                    }}
																										    
#define rtl_spin_unlock(x)   clear_bit(0,x.lock);
																										    
#else
#define rtl_spin_lock(x)  
#define rtl_spin_unlock(x)  
#endif

																										    
#define rtl_critical(f) {rtl_no_interrupts(f);\
	                     rtl_spin_lock(&RTL_SPIN_LOCK);}
#define rtl_end_critical(f) { rtl_spin_unlock(&RTL_SPIN_LOCK);\
	                   rtl_restore_interrupts(f);}

